<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @plugin Yandex Plugin
 * @copyright Copyright (C) Jan Pavelka www.yandex.cz
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.application.component.helper' );

class plgContentYandexMaps extends JPlugin
{	
	var $_plgYandexMapsNr	= 0;
	
	function _setYandexMapsPluginNumber() {
		$this->_plgYandexMapsNr = (int)$this->_plgYandexMapsNr + 1;
	}
	
	function plgContentYandexMaps( &$subject, $params ) {
        parent::__construct( $subject, $params  );
    }

	function onPrepareContent( &$article, &$params, $limitstart ) {

		
		// Start Plugin
		$regex_one		= '/({yandexmaps\s*)(.*?)(})/si';
		$regex_all		= '/{yandexmaps\s*.*?}/si';
		$matches 		= array();
		$count_matches	= preg_match_all($regex_all,$article->text,$matches,PREG_OFFSET_CAPTURE | PREG_PATTERN_ORDER);

		
		
		// Start if count_matches
		
		if ($count_matches != 0) {
		
			$document		= &JFactory::getDocument();
			$db 			= &JFactory::getDBO();
			$menu 			= &JSite::getMenu();			
			$plugin 		= &JPluginHelper::getPlugin('content', 'yandexmaps');
			$paramsP 		= new JParameter( $plugin->params );
			require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_yandexmaps'.DS.'helpers'.DS.'yandexmaps.php' );
			
			$component 		= 'com_yandexmaps';
			$table 			=& JTable::getInstance('component');
			$table->loadByOption( $component );
			$paramsC	 	= new JParameter( $table->params );
			$tmpl			= array();
			
			if (!JComponentHelper::isEnabled('com_yandexmaps', true)) {
				JText::_('Yandex Maps Plugin requires Yandex Maps Component');
				return true;
			}
			
			$document->addStyleSheet(JURI::base(true).'/components/com_yandexmaps/assets/yandexmaps.css');
			
			for($i = 0; $i < $count_matches; $i++) {
				
				$this->_setYandexMapsPluginNumber();
				$mC	= 'PlgPM'.(int)$this->_plgYandexMapsNr;
				
				$view	= '';
				$id		= '';
				$text	= '';
				
				// Get plugin parameters
				$yandexMaps	= $matches[0][$i][0];
				preg_match($regex_one,$yandexMaps,$yandexMaps_parts);
				$parts			= explode("|", $yandexMaps_parts[2]);
				$values_replace = array ("/^'/", "/'$/", "/^&#39;/", "/&#39;$/", "/<br \/>/");

				
				foreach($parts as $key => $value) {
					$values = explode("=", $value, 2);
					foreach ($values_replace as $key2 => $values2) {
						$values = preg_replace($values2, '', $values);
					}
					
					// Get plugin parameters from article
						 if($values[0]=='view')				{$view				= $values[1];}
					else if($values[0]=='id')				{$id				= $values[1];}
					else if($values[0]=='text')				{$text				= $values[1];}
					
				}
				
				$output = '';
				switch($view) {
					
					// - - - - - - - - - - - - - - - -
					// Map
					// - - - - - - - - - - - - - - - -
					case 'map':	

						$query = 'SELECT a.*'
						.' FROM #__yandexmaps_map AS a'
						.' WHERE a.id = '.(int) $id;
						$db->setQuery($query);
						$map = $db->loadObject();
						
						$query = 'SELECT a.*'
								.' FROM #__yandexmaps_marker AS a'
								.' LEFT JOIN #__yandexmaps_map AS c ON c.id = a.catid '
								.' WHERE c.id = '.(int) $id
								.' AND a.published = 1';
						$db->setQuery($query);
						$marker = $db->loadObjectList();
						
						if (empty($map)) {
							JError::raiseError('Yandex Maps Plugin Error', JText::_('Map does not exist or is unpublished') . ' (ID = '.$id.')');
						}
						
						// Parameters
						$tmpl['apikey']					= $paramsC->get( 'google_maps_api_key', '' );
						$tmpl['displayyandexinfo']		= $paramsC->get( 'display_yandex_info', 1 );
						$tmpl['displaymapdescription']	= $paramsP->get( 'display_map_description', 0 );
// - - - - - - - - - - - - - - - 						
// RENDER

if ($tmpl['apikey'] == '') {
	$output .= '<p>' . JText::_('Google Maps API Key Error Front') . '</p>';

} else if ((!isset($map->longitude))
		|| (!isset($map->latitude))
		|| (isset($map->longitude) && $map->longitude == '')
		|| (isset($map->latitude) && $map->latitude == '')) {
	$output .= '<p>' . JText::_('Google Maps Error Front') . '</p>';

} else {

	if (isset($map->description) && $map->description != '' && $tmpl['displaymapdescription'] == 1) {
		$output .= '<div class="pm-desc">'.$map->description.'</div>';
	}

	// Basic settings
	$fullWidth = 0;
	if (!isset($map->width)) {
		$map->width = 400;
	}
	if (isset($map->width) && (int)$map->width < 1) {
		$fullWidth = 1;
	}
	if (!isset($map->height) || (isset($map->height) && (int)$map->height < 1)) {
		$map->height = 400;
	}
	if (!isset($map->zoom) || (isset($map->zoom) && (int)$map->zoom < 1)) {
		$map->height = 2;
	}
	$mapLang = '';
	if (!isset($map->lang) || (isset($map->lang) && $map->lang =='')) {
		$mapLang = '';
	} else {
		$mapLang = $map->lang;
	}

	
	//$document	= & JFactory::getDocument();
	$scriptLink	= 'http://api-maps.yandex.ru/'.$mapLang.'/index.xml?key='. $tmpl['apikey']; //загружаем api
	$document->addScript($scriptLink);
	//$output.= '<noscript>'. JText::_('GOOGLE MAP ENABLE JAVASCRIPT').'</noscript>';

	
	// Map Box
	if ($fullWidth == 1) {//если 0 то растягиваем на 100%
	
	$output .= '<div id="YMapsID'.$mC.'" style="margin:0;padding:0;width:100%;height:'.$map->height.'px"></div>';
	
	}else{//если больше 0 то по заданным размерам
	$output .= '<div id="YMapsID'.$mC.'" style="margin:0;padding:0;width:'.$map->width.'px;height:'.$map->height.'px"></div>';			
		}	
	

if (isset($map->displayroute) && $map->displayroute == 1) {
	if (isset($marker) && !empty($marker)) {
		
		$countMarker = count($marker);
		if ((int)$countMarker > 1) {
			$output .= '<div class="pmroute"><form action="#" onsubmit="showAddress'.$mC.'(this.address'.$mC.'.value);return false;">';
			$output .= JText::_('From Address').': ';
			$output .= ' ' . JText::_('To').': <select id="address'.$mC.'">';
			foreach ($marker as $key => $markerV) {
				if ((isset($markerV->longitude) && $markerV->longitude != '')
				&& (isset($markerV->latitude) && $markerV->latitude != '')) {
					$output .= '<option value="'.$markerV->longitude.','.$markerV->latitude.'">'.$markerV->title.'</option>';
				}
			}
			$output .= '</select>';
			$output .= ' <input type="submit" value="'.JText::_('Get Route').'" /></form>';
			$output .= '</div>';
			$output .= '<form action="#" onsubmit="showAddress'.$mC.'(this.address2'.$mC.'.value);return false;"><p><input type="text" id="address2" style="width:525px;" value="" /><input type="submit" value="Искать" /></p>';
			
			$output .= ' </form>';
		} else if ((int)$countMarker == 1) {
			$output .= '<form action="#" onsubmit="showAddress'.$mC.'(this.address'.$mC.'.value);return false;"><p><input type="text" id="address'.$mC.'" style="width:525px;" value="Москва" /><input type="submit" value="Искать" /></p>';
			
			$output .= ' </form>';
			//$output .= '<div id="yandex_dir"></div>';
		}
	}
}

$output.=''."\n";
$output.='<script type="text/javascript">//<![CDATA['."\n";
$output .= 'var map'.$mC.', geoResult'.$mC.';' ."\n";

		$output .= 'YMaps.jQuery(function () {' ."\n";
		
        $output .= 'map'.$mC.' = new YMaps.Map(document.getElementById("YMapsID'.$mC.'"));' ."\n";
		
        $output .= 'map'.$mC.'.setCenter(new YMaps.GeoPoint( '.$map->longitude.', ' .$map->latitude.'), '.$map->zoom.');' ."\n";
		

if (isset($map->doubleclickzoom) && (int)$map->doubleclickzoom == 1) {
	$output .= 'map'.$mC.'.enableDblClickZoom();' ."\n";
} else {
	$output .= 'map'.$mC.'.disableDblClickZoom();' ."\n";
}

if (isset($map->scrollwheelzoom) && (int)$map->scrollwheelzoom == 1) {

	$output .= 'map'.$mC.'.enableScrollZoom();' ."\n";
} else {
	$output .= 'map'.$mC.'.disableScrollZoom();' ."\n";
}

if (isset($map->zoomcontrol)) {
	switch ($map->zoomcontrol) {
		
				case 1:
					$output .= 'map'.$mC.'.addControl(new YMaps.Zoom());' ."\n";
				break;
				case 2:
					$output .= 'map'.$mC.'.addControl(new YMaps.SmallZoom());' ."\n";
				break;
				default;
					$output .= '' ."\n";
				break;
	}
}

if (isset($map->scalecontrol) && (int)$map->scalecontrol == 1) {
	$output .= 'map'.$mC.'.addControl(new YMaps.ScaleLine());' ."\n";
}

if (isset($map->typecontrol)) {
	
	
	
	switch ($map->typecontrol) {
		
				case 1:
					$output .= 'map'.$mC.'.addControl(new YMaps.TypeControl());' ."\n";
				break;
				case 2:
					$output .= 'map'.$mC.'.setType(YMaps.MapType.MAP);' ."\n";
				break;
				case 3:
					$output .= 'map'.$mC.'.setType(YMaps.MapType.SATELLITE);' ."\n";
				break;
				case 4:
					$output .= 'map'.$mC.'.setType(YMaps.MapType.HYBRID);' ."\n";
				break;
				case 5:
					$output .= 'map'.$mC.'.setType(YMaps.MapType.HYBRID);' ."\n";
				break;
				
				case 7:
					$output .= 'map'.$mC.'.addControl(new YMaps.TypeControl());' ."\n";
					$output .= 'map'.$mC.'.setType(YMaps.MapType.SATELLITE);' ."\n";
				break;
				
				case 8:
					$output .= 'map'.$mC.'.addControl(new YMaps.TypeControl());' ."\n";
					$output .= 'map'.$mC.'.setType(YMaps.MapType.HYBRID);' ."\n";
				break;
				case 9:
					$output .= 'map'.$mC.'.addControl(new YMaps.TypeControl());' ."\n";
					$output .= 'map'.$mC.'.setType(YMaps.MapType.MAP);' ."\n";
				break;
				
				
				default;
					$output .= '' ."\n";
				break;
	}
}
//миникарта
if (isset($map->collapsibleoverview) && (int)$map->collapsibleoverview == 1) {
	$output .= 'map'.$mC.'.addControl(new YMaps.MiniMap());' ."\n";
}

//яндексбар
if (isset($map->googlebar) && (int)$map->googlebar == 1) {
	$output .= 'map'.$mC.'.addControl(new YMaps.ToolBar());' ."\n";
}
//поиск
if (isset($map->border) && (int)$map->border == 1) {
	$output .= 'map'.$mC.'.addControl(new YMaps.SearchControl());' ."\n";
}


// Маркер
jimport('joomla.filter.output');
if (isset($marker) && !empty($marker)) {

	foreach ($marker as $key => $markerV) {
	
		if ((isset($markerV->longitude) && $markerV->longitude != '')
		&& (isset($markerV->latitude) && $markerV->latitude != '')) {
			
			$text =  '<h1>' . addslashes($markerV->title) . '</h1>';
			$text .= '<div>'. YandexMapsHelper::strTrimAll(addslashes($markerV->description)).'</div>';
			if ($markerV->displaygps == 1) {
				$text .= '<div class="pmgps"><table border="0"><tr><td><strong>'. JText::_('GPS') . ': </strong></td>'
						.'<td>'.YandexMapsHelper::strTrimAll(addslashes($markerV->gpslatitude)).'</td></tr>'
						.'<tr><td></td>'
						.'<td>'.YandexMapsHelper::strTrimAll(addslashes($markerV->gpslongitude)).'</td></tr></table></div>';
			}
			
		
if ($markerV->icon != '') {

		  // Создание стиля для значка метки
          $output .=   'var s'.$markerV->id.$mC.' = new YMaps.Style();' ."\n";
          $output .=   's'.$markerV->id.$mC.'.iconStyle = new YMaps.IconStyle();' ."\n";
          $output .=   's'.$markerV->id.$mC.'.iconStyle.href = "'.JURI::base().'/components/com_yandexmaps/assets/images/icon/'.$markerV->icon.'";' ."\n";
		  //получаем размеры иконки
		  list($width, $height) = getimagesize(JPATH_SITE.'/components/com_yandexmaps/assets/images/icon/'.$markerV->icon); 	  
          $output .=   's'.$markerV->id.$mC.'.iconStyle.size = new YMaps.Point('.$width.', '.$height.');' ."\n";
          $output .=   's'.$markerV->id.$mC.'.iconStyle.offset = new YMaps.Point(-9, -29);' ."\n";
		  
				
		  $output .=	'var point'.$markerV->id.$mC.' = new YMaps.Placemark(new YMaps.GeoPoint('.$markerV->longitude.', '.$markerV->latitude.'), {style: s'.$markerV->id.$mC.', balloonOptions: {maxWidth: 200}});' ."\n";
							
		
		}else{
		
		 $output .= 'var point'.$markerV->id.$mC.' = new YMaps.Placemark(new YMaps.GeoPoint('.$markerV->longitude.', '.$markerV->latitude.'), {style: "default#'.$markerV->deficon.'", balloonOptions: {maxWidth: 200}});'."\n";
		 
		 	if (isset($map->continuouszoom) && (int)$map->continuouszoom == 1 && $markerV->titlem !== '') {
				$output .= 'point'.$markerV->id.$mC.'.setIconContent(\''.addslashes($markerV->titlem).'\');' ."\n";
			} else {
				$output .= 'point'.$markerV->id.$mC.'.setIconContent();' ."\n";
			}
							
		}
	
			
			$output .= 'map'.$mC.'.addOverlay(point'.$markerV->id.$mC.');' ."\n";
					
			$output .= 'point'.$markerV->id.$mC.'.setBalloonContent(\''.$text.'\', {maxWidth: 100});' ."\n";
      		
			//Открытый или закрытый балун  			
		 if (isset($map->dynamiclabel) && (int)$map->dynamiclabel == 1) {
			$output .= 'point'.$markerV->id.$mC.'.closeBalloon();' ."\n";
		} else {
			$output .= 'point'.$markerV->id.$mC.'.openBalloon();' ."\n";
			}
		}
	}
}
//$output.='	}'."\n";
$output.='});'."\n";
$output.=''."\n";


/*Directions*/
if (isset($map->displayroute) && $map->displayroute == 1) {
	if (isset($marker) && !empty($marker)) {
		
		$output .= 'function showAddress'.$mC.' (value) {' ."\n";
        $output .= '    map'.$mC.'.removeOverlay(geoResult'.$mC.');' ."\n";
        $output .= '    var geocoder = new YMaps.Geocoder(value, {results: 1, boundedBy: map'.$mC.'.getBounds()});' ."\n";

        $output .= '    YMaps.Events.observe(geocoder, geocoder.Events.Load, function () {' ."\n";
        $output .= '        if (this.length()) {' ."\n";
        $output .= '            geoResult'.$mC.' = this.get(0);' ."\n";
        $output .= '            map'.$mC.'.addOverlay(geoResult'.$mC.');' ."\n";
        $output .= '            map'.$mC.'.setBounds(geoResult'.$mC.'.getBounds());' ."\n";
        $output .= '        }else {' ."\n";
        $output .= '            alert("'.JText::_('An unknown error occurred').'")' ."\n";
        $output .= '        }' ."\n";
        $output .= '    });' ."\n";
        $output .= '}' ."\n";
	
	}
}

$output.= ''.'//]]></script>';	


}

	$output .= '<div style="text-align:right;margin-top:2px;clear:both; font-size:8px"><a href="http://yar-it.com">Разработка сайтов</a></div>';


// END RENDER
// - - - - - - - - - - - - - - - 						
						
						
						
					break;
					
					// - - - - - - - - - - - - - - - -
					// Выводим ссылкой в модальном или попап окне
					// - - - - - - - - - - - - - - - -
					case 'link':
						if ((int)$id > 0) {
						
							$query = 'SELECT a.*,'
							. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug'
							.' FROM #__yandexmaps_map AS a'
							.' WHERE a.id = '.(int) $id;
							$db->setQuery($query);
							$map = $db->loadObject();
							
							
							$query = 'SELECT a.id'
								.' FROM #__yandexmaps_marker AS a'
								.' LEFT JOIN #__yandexmaps_map AS c ON c.id = a.catid '
								.' WHERE c.id = '.(int) $id
								.' AND a.published = 1';
							$db->setQuery($query);
							$marker = $db->loadObjectList();
							
							if (empty($map)) {
							JError::raiseError('Yandex Maps Plugin Error', JText::_('Map does not exist or is unpublished') . ' (ID = '.$id.')');
						}
							
						
							// Is there a Itemid for category
							$items	 = $menu->getItems('link', 'index.php?option=com_yandexmaps&view=map&id='. $map->id);
							
							if(isset($items[0])) {
								$itemid = $items[0]->id;
								$linkMap = JRoute::_('index.php?option=com_yandexmaps&view=map&id='. $map->id.'&tmpl=component&Itemid='.$itemid );
							} else {							
								$itemid = 0;
								$linkMap = JRoute::_('index.php?option=com_yandexmaps&view=map&id='. $map->slug .'&tmpl=component' );
								
							}
							// ---------------------------------------------------------------------------------
					
							if ($text =='') {
								$text = JText::_('Link to Map');
							}
							
							// Parameters
							$tmpl['detailwindow']		= $paramsP->get( 'detail_window', 0 );
							$tmpl['mbbordercolor']		= $paramsP->get( 'modal_box_border_color', '#6b6b6b' );
							$tmpl['mbborderwidth']		= $paramsP->get( 'modal_box_border_width', 2 );
							$tmpl['mboverlaycolor']		= $paramsP->get( 'modal_box_overlay_color', '#000000' );
							$tmpl['mboverlayopacity']	= $paramsP->get( 'modal_box_overlay_opacity', 0.3 );
							
							
							if ($map->width > 0) {
								$tmpl['windowwidth'] = (int)$map->width + 20;
							} else {
								$tmpl['windowwidth'] = 640;
							}
							$tmpl['windowheight'] = (int)$map->height + 20;
							
							
							//Route
							if (isset($map->displayroute) && $map->displayroute == 1) {
								if (isset($marker) && !empty($marker)) {
									$tmpl['windowheight'] = (int)$tmpl['windowheight'] + 40;
								}
							}
							
							
							if ($tmpl['detailwindow'] == 1) {
								
								$button = new JObject();
								$button->set('name', 'yandexmaps');
								$button->set('methodname', 'js-button');
								$button->set('options', "window.open(this.href,'win2','width=".$tmpl['windowwidth'].",height=".$tmpl['windowheight'].",menubar=no,resizable=yes'); return false;");
								$output .= '<a title="'.$text.'"  href="'.$linkMap.'" onclick="'. $button->options.'">'.$text.'</a>';
								
								
							} else if ($tmpl['detailwindow'] == 0) {
							
								// Button
								JHTML::_('behavior.modal', 'a.modal-button');
								$cssSbox = " #sbox-window {background-color:".$tmpl['mbbordercolor'].";padding:".$tmpl['mbborderwidth']."px} \n"
								." #sbox-overlay {background-color:".$tmpl['mboverlaycolor'].";} \n";
				
								$document->addCustomTag( "<style type=\"text/css\">\n" . $cssSbox . "\n" . " </style>\n");
								
								$button = new JObject();
								$button->set('name', 'yandexmaps');
								$button->set('modal', true);
								$button->set('methodname', 'modal-button');
								$button->set('options', "{handler: 'iframe', size: {x: ".$tmpl['windowwidth'].", y: ".$tmpl['windowheight']."}, overlayOpacity: ".$tmpl['mboverlayopacity'].", classWindow: 'yandexmaps-plugin-window', classOverlay: 'yandexmaps-plugin-overlay'}");
							
								$output .= '<a class="modal-button" title="'.$text.'"  href="'.$linkMap.'" rel="'. $button->options.'">'.$text.'</a>';
							}
								
								
							
						}
					break;
					
				}

				$article->text = preg_replace($regex_all, $output, $article->text, 1);
				
			}
		}// end if count_matches
		return true;
	}
}
?>
